## workflow 0.9.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")
set(CMAKE_SKIP_RPATH TRUE)

project(
	workflow
	VERSION 0.9.8
	LANGUAGES C CXX
)

if (CYGWIN)
	message(FATAL_ERROR "Sorry, DO NOT support Cygwin")
endif ()

if (MINGW)
	message(FATAL_ERROR "Sorry, DO NOT support MinGW")
endif ()

include(GNUInstallDirs)

set(CMAKE_CONFIG_INSTALL_FILE ${PROJECT_BINARY_DIR}/config.toinstall.cmake)
set(CMAKE_CONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
set(INC_DIR ${PROJECT_SOURCE_DIR}/_include CACHE PATH "workflow inc")
set(LIB_DIR ${PROJECT_SOURCE_DIR}/_lib CACHE PATH "workflow lib")

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIB_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIB_DIR})

add_custom_target(
	LINK_HEADERS ALL
	COMMENT "link headers..."
)

INCLUDE(CMakeLists_Headers.txt)

macro(makeLink src dest target)
	add_custom_command(
		TARGET ${target} PRE_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dest}
		DEPENDS ${dest}
	)
endmacro()

add_custom_command(
	TARGET LINK_HEADERS PRE_BUILD
	COMMAND ${CMAKE_COMMAND} -E make_directory ${INC_DIR}/${PROJECT_NAME}
)

foreach(header_file ${INCLUDE_HEADERS} ${INCLUDE_KERNEL_HEADERS})
	string(REPLACE "/" ";" arr ${header_file})
	list(GET arr -1 file_name)
	makeLink(${PROJECT_SOURCE_DIR}/${header_file} ${INC_DIR}/${PROJECT_NAME}/${file_name} LINK_HEADERS)
endforeach()

message("CMAKE_C_FLAGS_DEBUG is ${CMAKE_C_FLAGS_DEBUG}")
message("CMAKE_C_FLAGS_RELEASE is ${CMAKE_C_FLAGS_RELEASE}")
message("CMAKE_C_FLAGS_RELWITHDEBINFO is ${CMAKE_C_FLAGS_RELWITHDEBINFO}")
message("CMAKE_C_FLAGS_MINSIZEREL is ${CMAKE_C_FLAGS_MINSIZEREL}")

message("CMAKE_CXX_FLAGS_DEBUG is ${CMAKE_CXX_FLAGS_DEBUG}")
message("CMAKE_CXX_FLAGS_RELEASE is ${CMAKE_CXX_FLAGS_RELEASE}")
message("CMAKE_CXX_FLAGS_RELWITHDEBINFO is ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
message("CMAKE_CXX_FLAGS_MINSIZEREL is ${CMAKE_CXX_FLAGS_MINSIZEREL}")

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
endif ()

add_subdirectory(src)

####CONFIG

include(CMakePackageConfigHelpers)
set(CONFIG_INC_DIR ${INC_DIR})
set(CONFIG_LIB_DIR ${LIB_DIR})
configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${PROJECT_SOURCE_DIR}/${PROJECT_NAME}-config.cmake
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR
)

set(CONFIG_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(CONFIG_LIB_DIR ${CMAKE_INSTALL_LIBDIR})
configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${CMAKE_CONFIG_INSTALL_FILE}
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR
)

install(
	FILES ${CMAKE_CONFIG_INSTALL_FILE}
	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	COMPONENT devel
	RENAME ${PROJECT_NAME}-config.cmake
)

install(
	FILES ${INCLUDE_HEADERS} ${INCLUDE_KERNEL_HEADERS}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
	COMPONENT devel
)

install(
	FILES README.md
	DESTINATION "${CMAKE_INSTALL_DOCDIR}-${PROJECT_VERSION}"
	COMPONENT devel
)

=== benchmark/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(benchmark
		LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

find_library(LIBRT rt)
find_package(OpenSSL REQUIRED)
find_package(workflow REQUIRED CONFIG HINTS ..)
include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
link_directories(${WORKFLOW_LIB_DIR})

if (WIN32)
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

set(BENCHMARK_LIST
	benchmark-01-http_server
	benchmark-02-http_server_long_req
)

if (APPLE)
	set(WORKFLOW_LIB workflow pthread z OpenSSL::SSL OpenSSL::Crypto)
else ()
	set(WORKFLOW_LIB workflow ${LIBRT})
endif ()

foreach(src ${BENCHMARK_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

if (NOT CMAKE_SYSTEM_NAME STREQUAL "Android")
	find_package(OpenSSL REQUIRED)
endif ()

include_directories(${OPENSSL_INCLUDE_DIR} ${INC_DIR}/workflow)

add_subdirectory(kernel)
add_subdirectory(util)
add_subdirectory(manager)
add_subdirectory(algorithm)
add_subdirectory(protocol)
add_subdirectory(factory)
add_subdirectory(nameservice)
add_subdirectory(server)
add_subdirectory(client)

add_dependencies(kernel LINK_HEADERS)
add_dependencies(util LINK_HEADERS)
add_dependencies(manager LINK_HEADERS)
add_dependencies(algorithm LINK_HEADERS)
add_dependencies(protocol LINK_HEADERS)
add_dependencies(factory LINK_HEADERS)
add_dependencies(nameservice LINK_HEADERS)
add_dependencies(server LINK_HEADERS)
add_dependencies(client LINK_HEADERS)

add_library(
	${PROJECT_NAME} STATIC
	$<TARGET_OBJECTS:kernel>
	$<TARGET_OBJECTS:util>
	$<TARGET_OBJECTS:manager>
	$<TARGET_OBJECTS:algorithm>
	$<TARGET_OBJECTS:protocol>
	$<TARGET_OBJECTS:factory>
	$<TARGET_OBJECTS:nameservice>
	$<TARGET_OBJECTS:server>
	$<TARGET_OBJECTS:client>
)

if (KAFKA STREQUAL "y")
	add_dependencies(client_kafka LINK_HEADERS)
	add_dependencies(util_kafka LINK_HEADERS)
	add_dependencies(protocol_kafka LINK_HEADERS)
	add_dependencies(factory_kafka LINK_HEADERS)
	add_library(
		"wfkafka" STATIC
		$<TARGET_OBJECTS:client_kafka>
		$<TARGET_OBJECTS:util_kafka>
		$<TARGET_OBJECTS:protocol_kafka>
		$<TARGET_OBJECTS:factory_kafka>
	)
endif ()

install(
	TARGETS ${PROJECT_NAME}
	ARCHIVE
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

if (APPLE)
	set(LIBSO ${LIB_DIR}/libworkflow.a)
else ()
	set(LIBSO ${LIB_DIR}/libworkflow.so)
	add_custom_target(
		SCRIPT_SHARED_LIB ALL
		COMMAND ${CMAKE_COMMAND} -E echo 'GROUP ( libworkflow.a AS_NEEDED ( libpthread.so libssl.so libcrypto.so ) ) ' > ${LIBSO}
	)
	add_dependencies(SCRIPT_SHARED_LIB ${PROJECT_NAME})
endif ()

if (KAFKA STREQUAL "y")
	if (APPLE)
		set(LIBSOKAFKA ${LIB_DIR}/libwfkafka.a)
	else ()
		set(LIBSOKAFKA ${LIB_DIR}/libwfkafka.so)
		add_custom_target(
			SCRIPT_SHARED_LIB_KAFKA ALL
			COMMAND ${CMAKE_COMMAND} -E echo 'GROUP ( libwfkafka.a AS_NEEDED ( libpthread.so libssl.so libcrypto.so ) ) ' > ${LIBSOKAFKA}
		)
		add_dependencies(SCRIPT_SHARED_LIB_KAFKA "wfkafka")
	endif ()
endif ()

install(
	FILES ${LIBSO}
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

if (KAFKA STREQUAL "y")
	install(
		FILES ${LIB_DIR}/libwfkafka.a
		DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)
	if (NOT APPLE)
		install(
			FILES ${LIBSOKAFKA}
			DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT devel
		)
	endif()
endif ()

install (
	TARGETS ${PROJECT_NAME} EXPORT ${CMAKE_PROJECT_NAME}-targets
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install (
	EXPORT ${CMAKE_PROJECT_NAME}-targets
	FILE ${CMAKE_PROJECT_NAME}-targets.cmake
	DESTINATION "${CMAKE_CONFIG_INSTALL_DIR}"
)

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(workflow_test
		LANGUAGES C CXX
)

find_library(LIBRT rt)
find_package(OpenSSL REQUIRED)
find_package(workflow REQUIRED CONFIG HINTS ..)
include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
link_directories(${WORKFLOW_LIB_DIR})

find_program(CMAKE_MEMORYCHECK_COMMAND valgrind)
set(memcheck_command ${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1 --leak-check=full)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

enable_testing()
find_package(GTest REQUIRED)

if (WIN32)
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

set(TEST_LIST
	task_unittest
	algo_unittest
	http_unittest
	redis_unittest
	mysql_unittest
	facilities_unittest
	graph_unittest
	memory_unittest
	upstream_unittest
	dns_unittest
	resource_unittest
	uriparser_unittest
)

if (APPLE)
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
else ()
	set(WORKFLOW_LIB workflow ${LIBRT})
endif ()

foreach(src ${TEST_LIST})
	add_executable(${src} EXCLUDE_FROM_ALL ${src}.cc)
	target_link_libraries(${src} ${WORKFLOW_LIB} GTest::GTest GTest::Main)
	add_test(${src} ${src})
	add_dependencies(check ${src})
endforeach()

foreach(src ${TEST_LIST})
	add_test(${src}-memory-check ${memcheck_command} ./${src})
endforeach()

=== tutorial/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(tutorial
		LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

find_library(LIBRT rt)
find_package(OpenSSL REQUIRED)
find_package(workflow REQUIRED CONFIG HINTS ..)
include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
link_directories(${WORKFLOW_LIB_DIR})

if (WIN32)
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
else ()
		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

set(TUTORIAL_LIST
	tutorial-00-helloworld
	tutorial-01-wget
	tutorial-04-http_echo_server
	tutorial-05-http_proxy
	tutorial-06-parallel_wget
	tutorial-07-sort_task
	tutorial-08-matrix_multiply
	tutorial-09-http_file_server
	tutorial-11-graph_task
)

if (APPLE)
	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
else ()
	set(WORKFLOW_LIB workflow ${LIBRT})
endif ()

foreach(src ${TUTORIAL_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()

if (NOT REDIS STREQUAL "n")
set(TUTORIAL_LIST
	tutorial-02-redis_cli
	tutorial-03-wget_to_redis
)
foreach(src ${TUTORIAL_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()
endif()

if (NOT MYSQL STREQUAL "n")
set(TUTORIAL_LIST
	tutorial-12-mysql_cli
)
foreach(src ${TUTORIAL_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
endforeach()
endif()

if (KAFKA STREQUAL "y")
	add_executable("kafka_cli" "tutorial-13-kafka_cli.cc")
	target_link_libraries("kafka_cli" wfkafka workflow z snappy lz4 zstd rt)
endif ()

set(DIR10 tutorial-10-user_defined_protocol)
add_executable(server ${DIR10}/server.cc ${DIR10}/message.cc)
add_executable(client ${DIR10}/client.cc ${DIR10}/message.cc)
target_link_libraries(server ${WORKFLOW_LIB})
target_link_libraries(client ${WORKFLOW_LIB})

set_target_properties(server PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
set_target_properties(client PROPERTIES
	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})

=== debian/changelog ===
workflow (0.9.8-1) unstable; urgency=medium

  * debian/patches/*: Removed online tests
  * debian/rules: Removed temporary skipping of make check
  * debian/control: Added libworkflow-dev
  * debian/rules: Removed unused comment line
  * Added install files
  * Cleanup of packaging, remove dependency on dh-exec
  * debian/copyright: updated licensing and copyright for crc32c.*
  * Initial release (Closes: #995460)

 -- Lance Lin <lqi254@protonmail.com>  Fri, 19 Nov 2021 22:02:54 +0700

=== debian/control ===
Source: workflow
Section: libs
Priority: optional
Maintainer: Lance Lin <lqi254@protonmail.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libssl-dev
Standards-Version: 4.2.1
Homepage: https://github.com/sogou/workflow
Vcs-Git: https://salsa.debian.org/debian/workflow.git
Vcs-Browser: https://salsa.debian.org/debian/workflow
Rules-Requires-Root: no

Package: libworkflow1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: Parallel computing and asynchronous web server engine
 Workflow can be used as a scalable web server to handle a variety
 of server workflows. It can be used to orchestrate complex
 relationships between computing and networking.  Workflow currently
 supports protocols for HTTP, Redis, MySQL, and Kafka.
 .
 This package contains the runtime library.

Package: libworkflow-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libworkflow1 (= ${binary:Version}),
         ${misc:Depends}
Description: Parallel computing and asynchronous web server engine
 Workflow can be used as a scalable web server to handle a variety
 of server workflows. It can be used to orchestrate complex
 relationships between computing and networking.  Workflow currently
 supports protocols for HTTP, Redis, MySQL, and Kafka.
 .
 This package contains the development header files.

## workflow 0.9.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.9.8
+	VERSION 0.9.9
 	LANGUAGES C CXX
 )

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,7 @@
 	tutorial-08-matrix_multiply
 	tutorial-09-http_file_server
 	tutorial-11-graph_task
+	tutorial-20-reducer
 )
 
 if (APPLE)

=== debian/changelog ===
workflow (0.9.9-1) unstable; urgency=medium

  * Update to version 0.9.9
  * debian/control: updated Standards Version to 4.6.0

 -- Lance Lin <lqi254@protonmail.com>  Mon, 20 Dec 2021 21:46:33 +0700

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libssl-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/sogou/workflow
 Vcs-Git: https://salsa.debian.org/debian/workflow.git
 Vcs-Browser: https://salsa.debian.org/debian/workflow

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export INSTALL_PREFIX = /usr/

%:
	dh $@

## workflow 0.9.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.9.9
+	VERSION 0.9.10
 	LANGUAGES C CXX
 )
 
@@ -94,11 +94,23 @@
 	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR
 )
 
+write_basic_package_version_file(
+	${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+	VERSION ${WORKFLOW_VERSION}
+	COMPATIBILITY AnyNewerVersion 
+)
+
 install(
 	FILES ${CMAKE_CONFIG_INSTALL_FILE}
 	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
 	COMPONENT devel
 	RENAME ${PROJECT_NAME}-config.cmake
+)
+
+install(
+	FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
+	COMPONENT devel
 )
 
 install(

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

if(ANDROID)
	include_directories(${OPENSSL_INCLUDE_DIR})
	link_directories(${OPENSSL_LINK_DIR})
else()
	find_package(OpenSSL REQUIRED)
endif ()

include_directories(${OPENSSL_INCLUDE_DIR} ${INC_DIR}/workflow)

if (KAFKA STREQUAL "y")
	find_path(SNAPPY_INCLUDE_PATH NAMES snappy.h)
	find_library(SNAPPY_LIB NAMES snappy)
	if ((NOT SNAPPY_INCLUDE_PATH) OR (NOT SNAPPY_LIB))
		message(FATAL_ERROR "Fail to find snappy with KAFKA=y")
	endif ()
	include_directories(${SNAPPY_INCLUDE_PATH})
endif ()

add_subdirectory(kernel)
add_subdirectory(util)
add_subdirectory(manager)
add_subdirectory(algorithm)
add_subdirectory(protocol)
add_subdirectory(factory)
add_subdirectory(nameservice)
add_subdirectory(server)
add_subdirectory(client)

add_dependencies(kernel LINK_HEADERS)
add_dependencies(util LINK_HEADERS)
add_dependencies(manager LINK_HEADERS)
add_dependencies(algorithm LINK_HEADERS)
add_dependencies(protocol LINK_HEADERS)
add_dependencies(factory LINK_HEADERS)
add_dependencies(nameservice LINK_HEADERS)
add_dependencies(server LINK_HEADERS)
add_dependencies(client LINK_HEADERS)

set(STATIC_LIB_NAME ${PROJECT_NAME}-static)
set(SHARED_LIB_NAME ${PROJECT_NAME}-shared)

add_library(
	${STATIC_LIB_NAME} STATIC
	$<TARGET_OBJECTS:kernel>
	$<TARGET_OBJECTS:util>
	$<TARGET_OBJECTS:manager>
	$<TARGET_OBJECTS:algorithm>
	$<TARGET_OBJECTS:protocol>
	$<TARGET_OBJECTS:factory>
	$<TARGET_OBJECTS:nameservice>
	$<TARGET_OBJECTS:server>
	$<TARGET_OBJECTS:client>
)

add_library(
	${SHARED_LIB_NAME} SHARED
	$<TARGET_OBJECTS:kernel>
	$<TARGET_OBJECTS:util>
	$<TARGET_OBJECTS:manager>
	$<TARGET_OBJECTS:algorithm>
	$<TARGET_OBJECTS:protocol>
	$<TARGET_OBJECTS:factory>
	$<TARGET_OBJECTS:nameservice>
	$<TARGET_OBJECTS:server>
	$<TARGET_OBJECTS:client>
)

if(ANDROID)
	target_link_libraries(${SHARED_LIB_NAME} ssl crypto c)
else()
	target_link_libraries(${SHARED_LIB_NAME} OpenSSL::SSL OpenSSL::Crypto pthread)
endif ()

set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})

if (KAFKA STREQUAL "y")
	add_dependencies(client_kafka LINK_HEADERS)
	add_dependencies(util_kafka LINK_HEADERS)
	add_dependencies(protocol_kafka LINK_HEADERS)
	add_dependencies(factory_kafka LINK_HEADERS)

	set(KAFKA_STATIC_LIB_NAME "wfkafka-static")
	add_library(
		${KAFKA_STATIC_LIB_NAME} STATIC
		$<TARGET_OBJECTS:client_kafka>
		$<TARGET_OBJECTS:util_kafka>
		$<TARGET_OBJECTS:protocol_kafka>
		$<TARGET_OBJECTS:factory_kafka>
	)
	set_target_properties(${KAFKA_STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka")

	set(KAFKA_SHARED_LIB_NAME "wfkafka-shared")
	add_library(
		${KAFKA_SHARED_LIB_NAME} SHARED
		$<TARGET_OBJECTS:client_kafka>
		$<TARGET_OBJECTS:util_kafka>
		$<TARGET_OBJECTS:protocol_kafka>
		$<TARGET_OBJECTS:factory_kafka>
	)
	if (APPLE)
		target_link_libraries(${KAFKA_SHARED_LIB_NAME}
							  workflow z lz4 zstd ${SNAPPY_LIB}
							  OpenSSL::SSL OpenSSL::Crypto pthread)
	endif ()
	set_target_properties(${KAFKA_SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka")
endif ()

install(
	TARGETS ${STATIC_LIB_NAME}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

install(
	TARGETS ${SHARED_LIB_NAME}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

if (KAFKA STREQUAL "y")
	install(
		TARGETS ${KAFKA_STATIC_LIB_NAME}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)
	install(
		TARGETS ${KAFKA_SHARED_LIB_NAME}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)
endif ()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
 if (APPLE)
 	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
 else ()
-	set(WORKFLOW_LIB workflow ${LIBRT})
+	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
 endif ()
 
 foreach(src ${TEST_LIST})

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -8,11 +8,20 @@
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})
 
-find_library(LIBRT rt)
-find_package(OpenSSL REQUIRED)
+if(ANDROID)
+	link_directories(${OPENSSL_LINK_DIR})
+else()
+	find_library(LIBRT rt)
+	find_package(OpenSSL REQUIRED)
+endif()
 find_package(workflow REQUIRED CONFIG HINTS ..)
 include_directories(${OPENSSL_INCLUDE_DIR} ${WORKFLOW_INCLUDE_DIR})
 link_directories(${WORKFLOW_LIB_DIR})
+
+if (KAFKA STREQUAL "y")
+	find_path(SNAPPY_INCLUDE_PATH NAMES snappy.h)
+	include_directories(${SNAPPY_INCLUDE_PATH})
+endif ()
 
 if (WIN32)
 		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
@@ -32,13 +41,16 @@
 	tutorial-08-matrix_multiply
 	tutorial-09-http_file_server
 	tutorial-11-graph_task
+	tutorial-15-name_service
 	tutorial-20-reducer
 )
 
 if (APPLE)
 	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
+elseif (ANDROID)
+	set(WORKFLOW_LIB workflow ssl crypto c)
 else ()
-	set(WORKFLOW_LIB workflow ${LIBRT})
+	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
 endif ()
 
 foreach(src ${TUTORIAL_LIST})
@@ -75,7 +87,7 @@
 
 if (KAFKA STREQUAL "y")
 	add_executable("kafka_cli" "tutorial-13-kafka_cli.cc")
-	target_link_libraries("kafka_cli" wfkafka workflow z snappy lz4 zstd rt)
+	target_link_libraries("kafka_cli" wfkafka ${WORKFLOW_LIB} z snappy lz4 zstd)
 endif ()
 
 set(DIR10 tutorial-10-user_defined_protocol)

=== src/algorithm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(algorithm)

set(SRC
	DnsRoutine.cc
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== src/client/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(client)

set(SRC
	WFDnsClient.cc
)

if (NOT MYSQL STREQUAL "n")
	set(SRC
		${SRC}
		WFMySQLConnection.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		WFKafkaClient.cc
	)
	add_library("client_kafka" OBJECT ${SRC})
	set_property(SOURCE WFKafkaClient.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
endif ()

=== src/factory/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(factory)

set(SRC
	WFGraphTask.cc
	DnsTaskImpl.cc
	WFTaskFactory.cc
	Workflow.cc
	HttpTaskImpl.cc
	WFResourcePool.cc
	FileTaskImpl.cc
)

if (NOT MYSQL STREQUAL "n")
	set(SRC
		${SRC}
		MySQLTaskImpl.cc
	)
endif ()

if (NOT REDIS STREQUAL "n")
	set(SRC
		${SRC}
		RedisTaskImpl.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		KafkaTaskImpl.cc
	)
	add_library("factory_kafka" OBJECT ${SRC})
	set_property(SOURCE KafkaTaskImpl.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
endif ()

=== src/protocol/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(protocol)

set(SRC
	dns_parser.c
	DnsMessage.cc
	DnsUtil.cc
	SSLWrapper.cc
	http_parser.c
	HttpMessage.cc
	HttpUtil.cc
)

if (NOT MYSQL STREQUAL "n")
	set(SRC
		${SRC}
		mysql_stream.c
		mysql_parser.c
		mysql_byteorder.c
		MySQLMessage.cc
		MySQLResult.cc
	)
endif ()

if (NOT REDIS STREQUAL "n")
	set(SRC
		${SRC}
		redis_parser.c
		RedisMessage.cc
	)
endif ()

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		kafka_parser.c
		KafkaMessage.cc
		KafkaDataTypes.cc
		KafkaResult.cc
	)
	add_library("protocol_kafka" OBJECT ${SRC})
	set_property(SOURCE KafkaMessage.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
	set_property(SOURCE KafkaDataTypes.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
	set_property(SOURCE KafkaResult.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
endif ()

=== src/util/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(util)

set(SRC
	EncodeStream.cc
	StringUtil.cc
	URIParser.cc
	MD5Util.cc
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

if (KAFKA STREQUAL "y")
	set(SRC
		crc32c.c
	)
	add_library("util_kafka" OBJECT ${SRC})
endif ()

=== debian/changelog ===
workflow (0.9.10-1) unstable; urgency=medium

  * Update to version 0.9.10

 -- Lance Lin <lqi254@protonmail.com>  Fri, 11 Feb 2022 19:50:58 +0700

workflow (0.9.9-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Let debhelper run cmake directly. (Closes: #1002712)

 -- Lance Lin <lqi254@protonmail.com>  Mon, 27 Dec 2021 11:37:07 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Package: libworkflow1
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Parallel computing and asynchronous web server engine
  Workflow can be used as a scalable web server to handle a variety
  of server workflows. It can be used to orchestrate complex
@@ -28,7 +28,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: libworkflow1 (= ${binary:Version}),
-         ${misc:Depends}
+         ${misc:Depends}, ${shlibs:Depends}
 Description: Parallel computing and asynchronous web server engine
  Workflow can be used as a scalable web server to handle a variety
  of server workflows. It can be used to orchestrate complex

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/workflow-$1\.tar\.gz/ \
  https://github.com/sogou/workflow/tags .*/v?(\d\S+)\.tar\.gz

## workflow 0.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.9.10
+	VERSION 0.10.1
 	LANGUAGES C CXX
 )

=== src/util/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 project(util)
 
 set(SRC
+	json_parser.c
 	EncodeStream.cc
 	StringUtil.cc
 	URIParser.cc

=== debian/changelog ===
workflow (0.10.1-1) unstable; urgency=medium

  * Update to version 0.10.1
  * d/control: Bump standards to 4.6.1
  * d/copyright: Update years to 2022
  * Fixed SONAME/SOVERSION issues. Closes: #1012544

 -- Lance Lin <lqi254@protonmail.com>  Fri, 17 Jun 2022 20:09:07 +0700

## workflow 0.10.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.1
+	VERSION 0.10.2
 	LANGUAGES C CXX
 )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -74,7 +74,7 @@
 endif ()
 
 set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
-set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
+set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
 
 if (KAFKA STREQUAL "y")
 	add_dependencies(client_kafka LINK_HEADERS)
@@ -105,7 +105,7 @@
 							  workflow z lz4 zstd ${SNAPPY_LIB}
 							  OpenSSL::SSL OpenSSL::Crypto pthread)
 	endif ()
-	set_target_properties(${KAFKA_SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka")
+	set_target_properties(${KAFKA_SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka" VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
 endif ()
 
 install(

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -42,6 +42,7 @@
 	tutorial-09-http_file_server
 	tutorial-11-graph_task
 	tutorial-15-name_service
+	tutorial-17-dns_cli
 	tutorial-20-reducer
 )

=== debian/changelog ===
workflow (0.10.2-1) unstable; urgency=medium

  * Update to version 0.10.2

 -- Lance Lin <lqi254@protonmail.com>  Wed, 29 Jun 2022 20:56:32 +0700

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,17 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libssl-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/sogou/workflow
 Vcs-Git: https://salsa.debian.org/debian/workflow.git
 Vcs-Browser: https://salsa.debian.org/debian/workflow
 Rules-Requires-Root: no
 
-Package: libworkflow1
+Package: libworkflow0
 Architecture: any
 Multi-Arch: same
+Breaks: libworkflow1 (<< 0.10.1-1)
+Replaces: libworkflow1 (<< 0.10.1-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Parallel computing and asynchronous web server engine
  Workflow can be used as a scalable web server to handle a variety
@@ -27,8 +29,9 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libworkflow1 (= ${binary:Version}),
-         ${misc:Depends}, ${shlibs:Depends}
+Breaks: libworkflow1 (<< 0.10.1-1)
+Replaces: libworkflow1 (<< 0.10.1-1)
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Parallel computing and asynchronous web server engine
  Workflow can be used as a scalable web server to handle a variety
  of server workflows. It can be used to orchestrate complex

## workflow 0.10.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.2
+	VERSION 0.10.3
 	LANGUAGES C CXX
 )

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -101,3 +101,13 @@
 	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
 set_target_properties(client PROPERTIES
 	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
+
+set(DIR16 tutorial-16-graceful_restart)
+add_executable(bootstrap ${DIR16}/bootstrap.c)
+add_executable(bootstrap_server ${DIR16}/server.cc)
+target_link_libraries(bootstrap_server ${WORKFLOW_LIB})
+
+set_target_properties(bootstrap PROPERTIES
+	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR16})
+set_target_properties(bootstrap_server PROPERTIES OUTPUT_NAME "server"
+	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR16})

=== debian/changelog ===
workflow (0.10.3-1) unstable; urgency=medium

  * Update to version 0.10.3

 -- Lance Lin <lqi254@protonmail.com>  Tue, 30 Aug 2022 19:47:16 +0700

## workflow 0.10.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.3
+	VERSION 0.10.4
 	LANGUAGES C CXX
 )

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -94,12 +94,20 @@
 set(DIR10 tutorial-10-user_defined_protocol)
 add_executable(server ${DIR10}/server.cc ${DIR10}/message.cc)
 add_executable(client ${DIR10}/client.cc ${DIR10}/message.cc)
+add_executable(server-uds ${DIR10}/server-uds.cc ${DIR10}/message.cc)
+add_executable(client-uds ${DIR10}/client-uds.cc ${DIR10}/message.cc)
 target_link_libraries(server ${WORKFLOW_LIB})
 target_link_libraries(client ${WORKFLOW_LIB})
+target_link_libraries(server-uds ${WORKFLOW_LIB})
+target_link_libraries(client-uds ${WORKFLOW_LIB})
 
 set_target_properties(server PROPERTIES
 	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
 set_target_properties(client PROPERTIES
+	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
+set_target_properties(server-uds PROPERTIES
+	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
+set_target_properties(client-uds PROPERTIES
 	RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/${DIR10})
 
 set(DIR16 tutorial-16-graceful_restart)

=== src/protocol/CMakeLists.txt ===
--- 
+++ 
@@ -2,10 +2,11 @@
 project(protocol)
 
 set(SRC
+	PackageWrapper.cc
+	SSLWrapper.cc
 	dns_parser.c
 	DnsMessage.cc
 	DnsUtil.cc
-	SSLWrapper.cc
 	http_parser.c
 	HttpMessage.cc
 	HttpUtil.cc
@@ -19,6 +20,7 @@
 		mysql_byteorder.c
 		MySQLMessage.cc
 		MySQLResult.cc
+		MySQLUtil.cc
 	)
 endif ()
 
@@ -41,6 +43,4 @@
 	)
 	add_library("protocol_kafka" OBJECT ${SRC})
 	set_property(SOURCE KafkaMessage.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
-	set_property(SOURCE KafkaDataTypes.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
-	set_property(SOURCE KafkaResult.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
 endif ()

=== debian/changelog ===
workflow (0.10.4-1) unstable; urgency=medium

  [ Lance Lin ]
  * New upstream version (0.10.4)
  * d/watch: new regex

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.

 -- Lance Lin <lqi254@protonmail.com>  Mon, 07 Nov 2022 21:47:12 +0700

## workflow 0.10.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.4
+	VERSION 0.10.5
 	LANGUAGES C CXX
 )

=== debian/changelog ===
workflow (0.10.5-1) unstable; urgency=medium

  * Update to version 0.10.5
  * d/control: Bump standards to 4.6.2
  * d/copyright: Update years to 2023

 -- Lance Lin <lq27267@gmail.com>  Mon, 09 Jan 2023 20:25:54 +0700

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: workflow
 Section: libs
 Priority: optional
-Maintainer: Lance Lin <lqi254@protonmail.com>
+Maintainer: Lance Lin <lq27267@gmail.com>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libssl-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/sogou/workflow
 Vcs-Git: https://salsa.debian.org/debian/workflow.git
 Vcs-Browser: https://salsa.debian.org/debian/workflow

## workflow 0.10.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.5
+	VERSION 0.10.6
 	LANGUAGES C CXX
 )

=== debian/changelog ===
workflow (0.10.6-1) unstable; urgency=medium

  * Update to version 0.10.6
  * d/control: Modified short description

 -- Lance Lin <lq27267@gmail.com>  Fri, 03 Mar 2023 22:10:31 +0700

=== debian/control ===
--- 
+++ 
@@ -32,7 +32,7 @@
 Breaks: libworkflow1 (<< 0.10.1-1)
 Replaces: libworkflow1 (<< 0.10.1-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Parallel computing and asynchronous web server engine
+Description: Parallel computing and asynchronous web server engine development files
  Workflow can be used as a scalable web server to handle a variety
  of server workflows. It can be used to orchestrate complex
  relationships between computing and networking.  Workflow currently

## workflow 0.10.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.6
+	VERSION 0.10.7
 	LANGUAGES C CXX
 )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -102,8 +102,9 @@
 	)
 	if (APPLE)
 		target_link_libraries(${KAFKA_SHARED_LIB_NAME}
-							  workflow z lz4 zstd ${SNAPPY_LIB}
-							  OpenSSL::SSL OpenSSL::Crypto pthread)
+							  ${SHARED_LIB_NAME} z lz4 zstd ${SNAPPY_LIB})
+	else ()
+		target_link_libraries(${KAFKA_SHARED_LIB_NAME} ${SHARED_LIB_NAME})
 	endif ()
 	set_target_properties(${KAFKA_SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME "wfkafka" VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
 endif ()

=== debian/changelog ===
workflow (0.10.7-1) unstable; urgency=medium

  * Update to version 0.10.7
  * d/source/lintian-overrides: Ignore very-long-line-length-in-source-file
      for tutorial documentation

 -- Lance Lin <lq27267@gmail.com>  Tue, 04 Jul 2023 20:08:26 +0700

workflow (0.10.6-2) unstable; urgency=medium

  [Bastian Germann]
  * d/libworkflow0.links: Fixed symlink direction (Closes: #1036653)

 -- Lance Lin <lq27267@gmail.com>  Wed, 31 May 2023 18:04:06 +0700

workflow (0.10.6-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Add missing Depends (Closes: #1035444)

 -- Bastian Germann <bage@debian.org>  Mon, 15 May 2023 11:56:58 +0200

## workflow 0.10.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.7
+	VERSION 0.10.8
 	LANGUAGES C CXX
 )

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -86,6 +86,18 @@
 endforeach()
 endif()
 
+if (NOT CONSUL STREQUAL "n")
+set(TUTORIAL_LIST
+	tutorial-14-consul_cli
+)
+foreach(src ${TUTORIAL_LIST})
+	string(REPLACE "-" ";" arr ${src})
+	list(GET arr -1 bin_name)
+	add_executable(${bin_name} ${src}.cc)
+	target_link_libraries(${bin_name} ${WORKFLOW_LIB})
+endforeach()
+endif()
+
 if (KAFKA STREQUAL "y")
 	add_executable("kafka_cli" "tutorial-13-kafka_cli.cc")
 	target_link_libraries("kafka_cli" wfkafka ${WORKFLOW_LIB} z snappy lz4 zstd)

=== debian/changelog ===
workflow (0.10.8-1) unstable; urgency=medium

  * Update to version 0.10.8
  * libworkflow0.install: Use wildcard for version number

 -- Lance Lin <lq27267@gmail.com>  Wed, 12 Jul 2023 20:01:17 +0700

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
 Multi-Arch: same
 Breaks: libworkflow1 (<< 0.10.1-1)
 Replaces: libworkflow1 (<< 0.10.1-1)
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, libworkflow0 (= ${binary:Version})
 Description: Parallel computing and asynchronous web server engine development files
  Workflow can be used as a scalable web server to handle a variety
  of server workflows. It can be used to orchestrate complex

=== debian/rules ===
--- 
+++ 
@@ -5,4 +5,4 @@
 export INSTALL_PREFIX = /usr/
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake

## workflow 0.10.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.8
+	VERSION 0.10.9
 	LANGUAGES C CXX
 )

=== debian/changelog ===
workflow (0.10.9-1) unstable; urgency=medium

  * Update to version 0.10.9

 -- Lance Lin <lq27267@gmail.com>  Fri, 08 Sep 2023 19:51:12 +0700

workflow (0.10.8-2) unstable; urgency=medium

  * d/clean: Remove autogenerated files (Closes: #1045724)

 -- Lance Lin <lq27267@gmail.com>  Wed, 16 Aug 2023 19:25:27 +0700

## workflow 0.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.10.9
+	VERSION 0.11.1
 	LANGUAGES C CXX
 )

=== debian/changelog ===
workflow (0.11.1-2) unstable; urgency=medium

  * d/rules: Skip build tests for mips64el

 -- Lance Lin <lq27267@gmail.com>  Mon, 13 Nov 2023 21:18:47 +0700

workflow (0.11.1-1) unstable; urgency=medium

  * Update to version 0.11.1
  * d/control: Add libgtest-dev to Build-Depends for tests
  * d/rules: Run upstream unittests during build
  * d/tests: Run upstream unittests for autopkgtest
  * d/patches: Refresh patches and add patch to add hardening flag

 -- Lance Lin <lq27267@gmail.com>  Fri, 03 Nov 2023 20:56:25 +0700

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Lance Lin <lq27267@gmail.com>
 Build-Depends: debhelper-compat (= 13),
                cmake,
+               libgtest-dev <!nocheck>,
                libssl-dev
 Standards-Version: 4.6.2
 Homepage: https://github.com/sogou/workflow

## workflow 0.11.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.1
+	VERSION 0.11.2
 	LANGUAGES C CXX
 )

=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -28,9 +28,9 @@
 )
 
 if (APPLE)
-	set(WORKFLOW_LIB workflow pthread z OpenSSL::SSL OpenSSL::Crypto)
+	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto)
 else ()
-	set(WORKFLOW_LIB workflow ${LIBRT})
+	set(WORKFLOW_LIB workflow pthread OpenSSL::SSL OpenSSL::Crypto ${LIBRT})
 endif ()
 
 foreach(src ${BENCHMARK_LIST})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,6 @@
 add_subdirectory(kernel)
 add_subdirectory(util)
 add_subdirectory(manager)
-add_subdirectory(algorithm)
 add_subdirectory(protocol)
 add_subdirectory(factory)
 add_subdirectory(nameservice)
@@ -31,7 +30,6 @@
 add_dependencies(kernel LINK_HEADERS)
 add_dependencies(util LINK_HEADERS)
 add_dependencies(manager LINK_HEADERS)
-add_dependencies(algorithm LINK_HEADERS)
 add_dependencies(protocol LINK_HEADERS)
 add_dependencies(factory LINK_HEADERS)
 add_dependencies(nameservice LINK_HEADERS)
@@ -46,7 +44,6 @@
 	$<TARGET_OBJECTS:kernel>
 	$<TARGET_OBJECTS:util>
 	$<TARGET_OBJECTS:manager>
-	$<TARGET_OBJECTS:algorithm>
 	$<TARGET_OBJECTS:protocol>
 	$<TARGET_OBJECTS:factory>
 	$<TARGET_OBJECTS:nameservice>
@@ -59,7 +56,6 @@
 	$<TARGET_OBJECTS:kernel>
 	$<TARGET_OBJECTS:util>
 	$<TARGET_OBJECTS:manager>
-	$<TARGET_OBJECTS:algorithm>
 	$<TARGET_OBJECTS:protocol>
 	$<TARGET_OBJECTS:factory>
 	$<TARGET_OBJECTS:nameservice>

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -18,14 +18,32 @@
 add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
 
 enable_testing()
+
+set(CXX_STD "c++11")
+
 find_package(GTest REQUIRED)
+if (GTest_VERSION VERSION_GREATER_EQUAL "1.13.0")
+	set(CXX_STD "c++14")
+else ()
+	get_filename_component(GTEST_PATH ${GTEST_LIBRARY} DIRECTORY ABSOLUTE)
+	execute_process(COMMAND grep Version "${GTEST_PATH}/pkgconfig/gtest.pc"
+					RESULT_VARIABLE GTEST_VERSION_RESULT
+					OUTPUT_VARIABLE GTEST_VERSION_OUTPUT)
+	if (${GTEST_VERSION_RESULT} EQUAL "0")
+		string(REPLACE " " ";" GTEST_VERSION_STR ${GTEST_VERSION_OUTPUT})
+		list(GET GTEST_VERSION_STR 1 GTEST_VERSION)
+		if (${GTEST_VERSION} VERSION_GREATER_EQUAL "1.13.0")
+			set(CXX_STD "c++14")
+		endif ()
+	endif ()
+endif ()
 
 if (WIN32)
 		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
 		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /std:c++14")
 else ()
 		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=${CXX_STD} -fno-exceptions")
 endif ()
 
 set(TEST_LIST
@@ -56,7 +74,8 @@
 	add_dependencies(check ${src})
 endforeach()
 
-foreach(src ${TEST_LIST})
-	add_test(${src}-memory-check ${memcheck_command} ./${src})
-endforeach()
-
+if (NOT ${CMAKE_MEMORYCHECK_COMMAND} STREQUAL "CMAKE_MEMORYCHECK_COMMAND-NOTFOUND")
+	foreach(src ${TEST_LIST})
+		add_test(${src}-memory-check ${memcheck_command} ./${src})
+	endforeach()
+endif ()

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,6 @@
 	tutorial-11-graph_task
 	tutorial-15-name_service
 	tutorial-17-dns_cli
-	tutorial-20-reducer
 )
 
 if (APPLE)

=== src/client/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,13 @@
 	)
 endif ()
 
+if (NOT CONSUL STREQUAL "n")
+	set(SRC
+		${SRC}
+		WFConsulClient.cc
+	)
+endif ()
+
 add_library(${PROJECT_NAME} OBJECT ${SRC})
 
 if (KAFKA STREQUAL "y")
@@ -19,5 +26,5 @@
 		WFKafkaClient.cc
 	)
 	add_library("client_kafka" OBJECT ${SRC})
-	set_property(SOURCE WFKafkaClient.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")
 endif ()
+

=== debian/changelog ===
workflow (0.11.2-1.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:43:35 +1100

workflow (0.11.2-1.1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:16:32 +0000

workflow (0.11.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063073

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 02:39:48 +0000

workflow (0.11.2-1) unstable; urgency=medium

  * New upstream version 0.11.2
  * Remove trailing whitespace in debian/copyright (routine-update)
  * d/copyright: Add missing copyrights and GPL-2+ license

 -- Lance Lin <lq27267@gmail.com>  Tue, 09 Jan 2024 19:55:45 +0700

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: workflow
 Section: libs
 Priority: optional
-Maintainer: Lance Lin <lq27267@gmail.com>
-Build-Depends: debhelper-compat (= 13),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Lance Lin <lq27267@gmail.com>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                cmake,
                libgtest-dev <!nocheck>,
                libssl-dev
@@ -12,11 +13,12 @@
 Vcs-Browser: https://salsa.debian.org/debian/workflow
 Rules-Requires-Root: no
 
-Package: libworkflow0
+Package: libworkflow0t64
+Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
-Breaks: libworkflow1 (<< 0.10.1-1)
-Replaces: libworkflow1 (<< 0.10.1-1)
+Breaks: libworkflow0 (<< ${source:Version}), libworkflow1 (<< 0.10.1-1)
+Replaces: libworkflow0, libworkflow1 (<< 0.10.1-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Parallel computing and asynchronous web server engine
  Workflow can be used as a scalable web server to handle a variety
@@ -32,7 +34,7 @@
 Multi-Arch: same
 Breaks: libworkflow1 (<< 0.10.1-1)
 Replaces: libworkflow1 (<< 0.10.1-1)
-Depends: ${misc:Depends}, ${shlibs:Depends}, libworkflow0 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libworkflow0t64 (= ${binary:Version})
 Description: Parallel computing and asynchronous web server engine development files
  Workflow can be used as a scalable web server to handle a variety
  of server workflows. It can be used to orchestrate complex

## workflow 0.11.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.2
+	VERSION 0.11.3
 	LANGUAGES C CXX
 )

=== debian/changelog ===
workflow (0.11.3-1) unstable; urgency=medium

  * New upstream version 0.11.3
  * Standards-Version: 4.7.0 (routine-update)

 -- Lance Lin <lq27267@gmail.com>  Thu, 25 Apr 2024 22:27:06 +0700

## workflow 0.11.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.3
+	VERSION 0.11.4
 	LANGUAGES C CXX
 )

=== debian/changelog ===
workflow (0.11.4-1) unstable; urgency=medium

  * New upstream version 0.11.4

 -- Lance Lin <lq27267@gmail.com>  Tue, 21 May 2024 19:43:36 +0700

## workflow 0.11.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.4
+	VERSION 0.11.5
 	LANGUAGES C CXX
 )
 
@@ -69,6 +69,9 @@
 else ()
 	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions -Wno-invalid-offsetof")
+	if (APPLE)
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+	endif()
 endif ()
 
 add_subdirectory(src)

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,9 @@
 else ()
 		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
 		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
+		if (APPLE)
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+		endif()
 endif ()
 
 set(TUTORIAL_LIST

=== debian/changelog ===
workflow (0.11.5-1) unstable; urgency=medium

  * New upstream version 0.11.5
  * d/patches: Refresh add_hardening_flag_for_tests.patch

 -- Lance Lin <lq27267@gmail.com>  Tue, 06 Aug 2024 19:29:42 +0700

## workflow 0.11.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 project(
 	workflow
-	VERSION 0.11.5
+	VERSION 0.11.6
 	LANGUAGES C CXX
 )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -44,6 +44,9 @@
 else ()
 		set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
 		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=${CXX_STD} -fno-exceptions")
+		if (APPLE)
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
+		endif()
 endif ()
 
 set(TEST_LIST

=== debian/changelog ===
workflow (0.11.6-2) unstable; urgency=medium

  * d/patches: Add patch to fix ill formed definition in srpc
  * d/clean: Clean build tests for subsequent builds

 -- Lance Lin <lq27267@gmail.com>  Thu, 31 Oct 2024 21:01:31 +0700

workflow (0.11.6-1) unstable; urgency=medium

  * New upstream version 0.11.6
  * d/libworkflow0t64.lintian-overrides: Remove unused override

 -- Lance Lin <lq27267@gmail.com>  Wed, 09 Oct 2024 20:04:44 +0700
